﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Threading;
using System.Net.Sockets;

namespace synclamp
{
    public partial class Form1 : Form
    {

        //private byte[] sendData;
      //  bool preState = false;

        //Boolean lampon = false;
        //Boolean lampoff = false;
        //Boolean lampbright = false;
        //Boolean lampdim = false;

        Thread serverThread = null;

        //int clientID = 0;
        const string BASE_URL = "http://siio.jp/~students/";
        const string LOG_URL = BASE_URL + "lamplog1.txt";
        const string UPDATE_URL = BASE_URL + "lampwrite1.php?state=";

        //const string[] LOG_URLS = new string[2]{BASE_URL + "lamplog1.txt",
        //                                            BASE_URL + "lamplog2.txt"};

        //const string[] UPDATE_URLS = new string[2]{BASE_URL + "lampwrite1.php?state=",
        //                                                 BASE_URL + "lampwrite2.php?state="};
        
        //PhidgetServerのIPアドレス/ポート
        const string PHIDGET_IP = "127.0.0.1";
        const int PHIDGET_PORT = 4321;
        #region 変数/定数

        //テキストボックスの最大表示文字数
        const int TEXTBOX_CNT_MAX = 10000;

        //連続読み取り用のスレッド
        Thread rxThread = null;

        //タイマー用のスレッド
        //Thread timerThread = null;

        //連続Pollingのデフォルト値(msec)
        const int RX_THREAD_INTERVAL = 100;

        //連続Pollingの間隔
        int rxThreadInterval = RX_THREAD_INTERVAL;

        //PhidgetServerへ接続するためのTCP Client
        TcpClient phidgetClient = null;

        //PhidgetServerとの通信タイムアウト時間
        const int TIMEOUT_SERVER_RX = 1000;
        const int TIMEOUT_SERVER_TX = 1000;

        //アイテム登録用のHashtable
//        Hashtable userHolder = new Hashtable();

        //保存ファイル名
        const string USER_FILE = "users.txt";
        const string SETTING_FILE = "setting.txt";
        //区切り子
        const string DELIMITER = "\t";

        //現在の体重値
        double currentWeight = 0.0;

        //体重登録完了フラグ
        bool weightRegistered = false;

        //タイマー稼動状態フラグ
        bool timerWeightWorking = false;

        //タイマー変動監視フラグ
        bool timerWeightChanged = false;

        //現在のIDを保持する変数
        string currentId = "0";

        //メッセージ出力フラグ
        bool messageEnabled = true;

        //システム終了フラグ
        bool disposing = false;



        #endregion


        #region PhidgetServerの接続とスレッド開始/停止
        //PhidgetServerに接続する
        public bool ConnectPhidget(IPAddress ip, int port)
        {
            try
            {
                IPEndPoint ipEndPoint = new IPEndPoint(ip, port);
                phidgetClient = new TcpClient();
                phidgetClient.Connect(ipEndPoint);
                phidgetClient.ReceiveTimeout = TIMEOUT_SERVER_RX;
                phidgetClient.SendTimeout = TIMEOUT_SERVER_TX;
                return true;
            }
            catch (Exception ex)
            {
             //   PrintError(ex.Message);
                return false;
            }
        }

        //スレッドを開始する
        private void StartPhidgetThread()
        {
            if (rxThread == null)
            {
                rxThread = new Thread(new ThreadStart(RxPhidgetWorker));
                rxThread.Start();
            }
        }

        //スレッドを停止する
        private void StopPhidgetThread()
        {
            if (rxThread != null)
            {
                rxThread.Abort();
                rxThread.Join();
                rxThread = null;
            }
            //if (timerThread != null)
            //{
            //    timerThread.Abort();
            //    timerThread = null;
            //}
        }

        //連続読み取りを処理するスレッド
        private void RxPhidgetWorker()
        {
            StreamReader reader = new StreamReader(phidgetClient.GetStream(),
                                                        System.Text.Encoding.ASCII);

            try
            {
                while (true)
                {
                    Thread.Sleep(rxThreadInterval);
                    try
                    {
                        string line = reader.ReadLine();
                      //  PrintDebug(line);
                        Parse(line);
                    }
                    catch (IOException ex)
                    {
                        continue;
                    }
                }
            }
            catch (ThreadAbortException ex)
            {
                return;
            }
            catch (Exception ex)
            {
             //   PrintError(ex.ToString());
                return;
            }
        }

        bool weightFlag = false;

        //PhidgetServerからのメッセージを解析
        private bool Parse(string line)
        {
            bool result = false;
            string[] args = line.Split(",".ToCharArray());

            if (args[0] == "In")
            {
               if (args[1] == "Weight")
                {
                    double weight = double.Parse(args[2]) ;

                    if (weight > 10)
                    {
                        if (!weightFlag)
                        {
                            weightFlag = true;
                            SendCommand(true);
                            Thread.Sleep(1);
                            SendCommand2(true);
                        }

                    }
                    else
                    {
                        if (weightFlag)
                        {
                            weightFlag = false;
                            SendCommand(false);
                            Thread.Sleep(1);
                            SendCommand2(false);
                        }
                    }
                    //if (!weightRegistered)
                        //numericUpDownWeight.Value = (decimal)weight;

                    //if (weight < (double)numericUpDownWeightReset.Value)
                    //{
                      //  ClearWeight();
                    //}
                    //else
                    //{
                      //  if (!weightRegistered)
                        //{
                          //  if (!timerWeightWorking)
                            //{
                              //  StartTimer(weight);
                            //}
                            //else
                           // {
                            //    UpdateTimer(weight);
                            //}
                       // }
                    //}
                    result = true;
                }
            }
            return result;
        }
        

      
        #endregion





        //コンストラクタ
        public Form1()
        {
            InitializeComponent();
            try
            {
                serialPort1.PortName = comboBoxPort.SelectedItem.ToString();
                serialPort1.Open();
            }
            catch(Exception ex)
            {

            }

            ConnectPhidget(IPAddress.Parse(PHIDGET_IP), PHIDGET_PORT);
            StartPhidgetThread();

            Thread.Sleep(1000);
            serverThread = new Thread(new ThreadStart(ServerWorker));
            serverThread.Start();
        }

        

        private void ServerWorker()
        {
            /*
            try
            {
                
                while (true)
                {
                    //System.Net.WebClient web = new System.Net.WebClient();
                    //HttpWebRequest
                    //Stream stream = web.OpenRead(new Uri(""));
                    //StreamReader reader = new StreamReader(stream);
                    //   System.IO.StreamReader reader = new StreamReader(web.OpenRead("http://192.168.108.2/~students/lamplog2.txt"));
                    //String s = reader.ReadToEnd();
                    //reader.Close();
                    //web.Dispose();


                    HttpWebRequest request = null;
                    HttpWebResponse response = null;
                    Stream responseStream = null;
                    StreamReader responseReader = null;
                    string responseBody = null; 


                    try
                    {
                        request = (HttpWebRequest)HttpWebRequest.Create(LOG_URL);
                        request.Method = "GET";
                        response = (HttpWebResponse)request.GetResponse();
                        responseStream = response.GetResponseStream();
                        responseReader = new StreamReader(responseStream);
                        responseBody = responseReader.ReadToEnd();

                    }
                    catch
                    {
                    }
                    finally
                    {
                        if (responseReader != null)
                            responseReader.Close();
                        if (responseStream != null)
                            responseStream.Close();
                        if (request != null)
                            request.Abort();
                    }



                    if (responseBody == "0")
                    {
                        //   textBox1.Text = "OK";
                        //if (preState)
                        //{

                            SendCommand(false);
                           // preState = false;
                       // }

                    }
                    else
                    {
                       // if (!preState)
                       // {
                            SendCommand(true);
                         //   preState = true;
                        //}
                    }
                }
            }
            catch (ThreadAbortException ex)
            {

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
             */
          
        }

        int connect_cnt1 = 0, connect_cnt2 = 0;

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            /*
          //リモコンからのon,off
            //on 78, 46, 4C, 31, 0D, 78, 46, 45, 31, 0D
            //off 78, 46, 4C, 31, 0D, 78, 46, 47, 31, 0D
          
          //X!0の仕様書に書かれてる値  
            //on 58, 46, 4C, 31, 0D, 58, 46, 45, 31, 0D

            byte[] rcvData = new byte[1];
            serialPort1.Read(rcvData, 0, 1);
            if (rcvData[0] == 78)
            {
                serialPort1.Read(rcvData, 0, 1);
                if (rcvData[0] == 46)
                {
                    serialPort1.Read(rcvData, 0, 1);
                    if (rcvData[0] == 45)
                    {
                        textBox1.Text = "lampon" + connect_cnt1.ToString();
                        connect_cnt1++;

                        System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Reload);
                        HttpWebRequest.DefaultCachePolicy = policy;

                        HttpWebRequest req = (HttpWebRequest)WebRequest.Create(UPDATE_URL + "1");
                        WebResponse res = req.GetResponse();
                        res.Close();
                    }
                    else if (rcvData[0] == 47)
                    {
                        textBox2.Text = "lampoff" + connect_cnt2.ToString();
                        connect_cnt2++;

                        System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Reload);
                        HttpWebRequest.DefaultCachePolicy = policy;

                        HttpWebRequest req = (HttpWebRequest)WebRequest.Create(UPDATE_URL + "0");
                        //  HttpWebRequest req = (HttpWebRequest)WebRequest.Create("http://192.168.108.2/~students/lampwrite1.php?state=0");
                        WebResponse res = req.GetResponse();
                        res.Close();
                    }
                }
            }

            //ここからもとのプログラム

        //    byte[] rcvData = new byte[12];

          //  int cnt = 0;
            //while (cnt < rcvData.Length)
            //{
              //  byte b = (byte)serialPort1.ReadByte();
                // if (b != 0x00)
                
                 //{
                   // rcvData[cnt] = b;
                    //cnt++;
                //}
            //}

//            CheckForIllegalCrossThreadCalls = false;//120,70,76,49,13 (on)[69][71]

  //          for (int i = 0; i < 12; i++)
    //        {

      //          if (rcvData[i] == 45) //rcvData[10] == 69
        //        {

          //          textBox1.Text = "lampon" + connect_cnt1.ToString();
            //        connect_cnt1++;

              //      System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Reload);
                //    HttpWebRequest.DefaultCachePolicy = policy;
            //
              //      HttpWebRequest req = (HttpWebRequest)WebRequest.Create(UPDATE_URL + "1");
                //    WebResponse res = req.GetResponse();
                  //  res.Close();

                //}
                //else if (rcvData[i] == 47) //rcvData[10] == 71
                //{
                  //  textBox2.Text = "lampoff" + connect_cnt2.ToString();
                    //connect_cnt2++;

                    //System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Reload);
                    //HttpWebRequest.DefaultCachePolicy = policy;

                    //HttpWebRequest req = (HttpWebRequest)WebRequest.Create(UPDATE_URL + "0");
                    ////  HttpWebRequest req = (HttpWebRequest)WebRequest.Create("http://192.168.108.2/~students/lampwrite1.php?state=0");
                    //WebResponse res = req.GetResponse();
                    //res.Close();
                //}
           // }
            */
        }

        private void SendCommand(bool on)
        {

            byte [] sendData = new byte[6];
            sendData[0] = 0x02;
            if (serialPort1.IsOpen)
            {
                serialPort1.Write(sendData, 0, 1);

                Thread.Sleep(2);


                sendData[1] = 0x63;
                sendData[2] = 0x46;
                sendData[3] = 0x4C;
                if (on)
                {
                    sendData[4] = 0x45;
                }
                else
                {
                    sendData[4] = 0x47;
                }
                sendData[5] = 0x41;

                serialPort1.Write(sendData, 1, 5);
            }

            return;
        }

        private void SendCommand2(bool on)
        {

            byte[] sendData = new byte[6];
            sendData[0] = 0x02;
            if (serialPort1.IsOpen)
            {
                serialPort1.Write(sendData, 0, 1);

                Thread.Sleep(2);


                sendData[1] = 0x63;
                sendData[2] = 0x46;
                sendData[3] = 0x5C;
                if (on)
                {
                    sendData[4] = 0x45;
                }
                else
                {
                    sendData[4] = 0x47;
                }
                sendData[5] = 0x41;

                serialPort1.Write(sendData, 1, 5);
            }

            return;
        }

        private void On_Click(object sender, EventArgs e)
        {

            SendCommand(true);
          /*System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Reload);
           // HttpWebRequest.DefaultCachePolicy = policy;

            //HttpWebRequest req = (HttpWebRequest)WebRequest.Create(UPDATE_URL + "1");
            //WebResponse res = req.GetResponse();
            //res.Close();
            */
        }

        private void Off_Click(object sender, EventArgs e)
        {
            SendCommand(false);
            
            /*
            System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Reload);
            HttpWebRequest.DefaultCachePolicy = policy;

            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(UPDATE_URL + "0");
            WebResponse res = req.GetResponse();
            res.Close();
             */
        }


        private void Dim_Click(object sender, EventArgs e)
       {
          //  sendData[4] = 0x49;
        }

        private void Bright_Click(object sender, EventArgs e)
        {
          //  sendData[4] = 0x4B;
        }


        private void comboBoxPort_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (serialPort1 != null && serialPort1.IsOpen)
                serialPort1.Close();
            serialPort1.Close();
            serialPort1.PortName = comboBoxPort.SelectedItem.ToString();
            serialPort1.Open();
        }

       

       
    }
}